# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b721"
os.chdir("/Users/wstein/.sage/sage_notebook/worksheets/admin/164/cells/341")
sage.server.notebook.interact.SAGE_CELL_ID=341
_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_1p3 = RealNumber('1.3'); _sage_const_1p5 = RealNumber('1.5'); _sage_const_1p7 = RealNumber('1.7'); _sage_const_0p3 = RealNumber('0.3')
def f(s, braces=True):
    t = ', '.join(sorted(list(s)))
    if braces: return '{' + t + '}'
    return t
def g(s): return set(str(s).replace(',',' ').split())

@interact
def _(X='1,2,3,a', Y='2,a,3,4,apple', Z='a,b,10,apple'):
    S = [g(X), g(Y), g(Z)]
    X,Y,Z = S
    XY = X.intersection(Y)
    XZ = X.intersection(Z)
    YZ = Y.intersection(Z)
    XYZ = XY.intersection(Z)
    html('<center>')
    html("$X \cap Y$ = %s"%f(XY))
    html("$X \cap Z$ = %s"%f(XZ))
    html("$Y \cap Z$ = %s"%f(YZ))
    html("$X \cap Y \cap Z$ = %s"%f(XYZ))
    html('</center>')
    centers = [(cos(n*_sage_const_2 *pi/_sage_const_3 ), sin(n*_sage_const_2 *pi/_sage_const_3 )) for n in [_sage_const_0 ,_sage_const_1 ,_sage_const_2 ]]
    scale = _sage_const_1p7
    clr = ['yellow', 'blue', 'green']
    G = Graphics()
    for i in range(len(S)):
        G += circle(centers[i], scale, rgbcolor=clr[i],
             fill=True, alpha=_sage_const_0p3 )
    for i in range(len(S)):
        G += circle(centers[i], scale, rgbcolor='black')

    # Plot what is in one but neither other
    for i in range(len(S)):
        Z = set(S[i])
        for j in range(_sage_const_1 ,len(S)):
            Z = Z.difference(S[(i+j)%_sage_const_3 ])
        G += text(f(Z,braces=False), (_sage_const_1p5 *centers[i][_sage_const_0 ],_sage_const_1p7 *centers[i][_sage_const_1 ]), rgbcolor='black')


    # Plot pairs of intersections
    for i in range(len(S)):
        Z = set(S[i]).intersection(S[(i+_sage_const_1 )%_sage_const_3 ]).difference(set(XYZ))
        C = (_sage_const_1p3 *cos(i*_sage_const_2 *pi/_sage_const_3  + pi/_sage_const_3 ), _sage_const_1p3 *sin(i*_sage_const_2 *pi/_sage_const_3  + pi/_sage_const_3 ))
        G += text(f(Z,braces=False), C, rgbcolor='black')

    # Plot intersection of all three
    G += text(f(XYZ,braces=False), (_sage_const_0 ,_sage_const_0 ), rgbcolor='black')

    # Show it
    G.show(aspect_ratio=_sage_const_1 , axes=False)

print "e721"
